<?php
/***************************************************************************
 *   Professional Download System                                          *
 *                                                                         *
 *   Copyright (C) pirdani                                                 *
 *   pirdani@hotmail.de                                                    *
 *   http://pirdani.de/                                                    *
 *                                                                         *
 *   Copyright (C) 2005 EdEdster (Stefan Noss)                             *
 *   http://edsterathome.de/                                               *
 *                                                                         *
 *   Copyright (C) 2006 Artur Wiebe                                        *
 *   wibix@gmx.de                                                          *
 *   http://wibix.de/                                                      *
 *                                                                         *
 *   Released under the terms & conditions of v2 of the                    *
 *   GNU General Public License. For details refer to                      *
 *   the included gpl.txt file or visit http://gnu.org                     *
 ***************************************************************************/
require_once("../../maincore.php");
require_once(BASEDIR."subheader.php");
require_once(BASEDIR."side_left.php");

require_once("include/common.php");
if(!pdp_check_access($pdp_settings['downbereich'])) {
	fallback("error.php?errno=".PDP_EACCESS);
}
//require_once("include/themes.php");


if(isset($_GET['catid']) && isNum($_GET['catid'])) {
	$catid = $_GET['catid'];
} else {
	$catid = 0;
}
if(isset($did)) {
	$catid = $pdp_dl['cat_id'];
}


function pdp_count_dl($cat, $count_where) {
	$count = dbcount("(*)", "pdp_downloads",
		"(cat_id='$cat' $count_where)");
	$query_id = dbquery("SELECT cat_name, cat_access, cat_id"
		." FROM ".DB_PREFIX."pdp_cats"
		." WHERE top_cat='$cat'");
	while($data = dbarray($query_id)) {
		if(pdp_check_access($data['cat_access'])) {
			$count += pdp_count_dl($data['cat_id'], $count_where);
		}
	}
	return $count;
}

function pdp_count_cats($cat) {
        $count = 0;
        $query_id = dbquery("SELECT cat_id, cat_access"
                ." FROM ".DB_PREFIX."pdp_cats"
                ." WHERE top_cat='$cat'");
        while($data = dbarray($query_id)) {
                if(pdp_check_access($data['cat_access'])) {
                        $count += pdp_count_cats($data['cat_id']) + 1;
                }
        }
        return $count;
}


if(!function_exists("show_cats")) {
function show_cats($catid, $is_did, $hide_cats)
{
	global $locale, $sorting, $userdata;

	$access_ok = NULL;
	$bullet = "<img src='".THEME."images/bullet.gif' alt=''>";

	$depth = 4;
	$localid = $catid;
	$path = array();
	while(--$depth>=0) {
		$topcat_id = dbquery("SELECT cat_id, cat_name, top_cat,"
			." cat_sorting, cat_access"
			." FROM ".DB_PREFIX."pdp_cats"
			." WHERE cat_id='$localid'");
		if(!$topcat_id || dbrows($topcat_id)==0) {
			break;
		}
		$topcat = dbarray($topcat_id);
		if($localid == $catid) {
			$access_ok = (pdp_check_access($topcat['cat_access'])
				? NULL : $topcat['cat_access']);
		}

		if($localid==$catid) {
			$sorting = $topcat['cat_sorting'];
		}

		$localid = $topcat['top_cat'];
		$path[] = "$bullet <a href='".FUSION_SELF
			."?catid=".$topcat['cat_id']."'>"
			.$topcat['cat_name']."</a>";

//FIXME		if($localid['top_cat']==0) {
		if($localid==0) {
			break;
		}
	}
	if($depth < 0) {
		$path[] = "..";
	}
	$path[] = "$bullet <a href='".FUSION_SELF."?catid=0'>".$locale['PDP820']
		."</a>";
	if(!$is_did && count($path)) {
		$path[0] = "$bullet <b>".strip_tags($path[0])."</b>";
	}

	/*wibix DISPLAY PATH*/
	$path = array_reverse($path);
	$path_str = "";
	foreach($path as $entry) {
		$path_str .= "$entry\n<div style='padding-left:10px;'>\n";
	}
	foreach($path as $entry) {
		$path_str .= "</div>\n";
	}
	$depth = count($path);

	/*wibix do not show sub cats on a specific download*/
	echo "<table border='0' width='100%' cellspacing='0' cellpadding='0'>\n"
		."<tr><td colspan='2' class=''>$path_str</td>";
	if($is_did) {
		echo "</tr>\n";
		echo "</table>\n";
		return $access_ok;
	}

	// FIXME need cat_desc?
	$cats = dbquery("SELECT * FROM ".DB_PREFIX."pdp_cats"
		." WHERE top_cat='$catid' ORDER by cat_name");
	$depth = ($depth*10);
	if(iPDP_ADMIN) {
		$count_where = "";
	} elseif(iMEMBER) {
		$count_where = " AND (dl_status!='".PDP_PRO_OFF."'"
			." OR user_id='".$userdata['user_id']."')";
	} else {
		$count_where = " AND dl_status!='".PDP_PRO_OFF."'";
	}
	while($cdata = dbarray($cats)) {
		if(!pdp_check_access($cdata['cat_access'])) {
			continue;
		}
		$cnt_dl = pdp_count_dl($cdata['cat_id'], $count_where);
		$cnt_cats = pdp_count_cats($cdata['cat_id']);

		$more = array();
		if($cnt_dl) {
			$more[] = $cnt_dl." ".$locale['PDP004'];
		}
		if($cnt_cats) {
			$more[] = $cnt_cats." ".$locale['PDP222'];
		}

		echo "<tr>\n<td class='' width='$depth'></td>"
			."<td class=''>$bullet"
				." <a href='".FUSION_SELF
				."?catid=".$cdata['cat_id']."'>"
				.$cdata['cat_name']."</a>";
		if(count($more)) {
			echo " (".implode(" - ", $more).")";
		}
		echo "</tr>\n";
	}
	echo "</table>\n";

	return $access_ok;
}
}


function show_downloads($catid)
{
	global $pdp_settings, $locale, $sorting, $userdata;

	$rowstart = 0;
	if(isset($_GET['rowstart']) && isNum($_GET['rowstart'])) {
		$rowstart = $_GET['rowstart'];
	}

	/* SHOW CAT DOWNLOADS */
	if(iPDP_ADMIN) {
		$where = "";
	} elseif(iMEMBER) {
		$where = "(dl_status!='".PDP_PRO_OFF."'"
			." OR dl.user_id='".$userdata['user_id']."') AND ";
	} else {
		$where = "(dl_status!='".PDP_PRO_OFF."') AND ";
	}
	$query = "SELECT dl.dl_id, dl.dl_name, dl.dl_mtime, dl.dl_count, dl.dl_pic,"
		." dl.cat_id, dl.version, dl.dl_status, fu.user_name,"
		." fu.user_id, dl.dl_desc"
		." FROM ".DB_PREFIX."pdp_downloads AS dl"
		." LEFT JOIN ".DB_PREFIX."users AS fu ON fu.user_id=dl.user_id"
		." LEFT JOIN ".DB_PREFIX."pdp_cats AS c ON dl.cat_id=c.cat_id";
	$where .= "dl.cat_id='$catid'";

	$query .= " WHERE $where";
	$query .= " ORDER BY dl.dl_$sorting";
	$query .= " LIMIT $rowstart, ".$pdp_settings['per_page'];

	$query_id = dbquery($query);

	// show
	if(dbrows($query_id)) {
		echo "<hr>";
	}
	$dl_count = dbrows($query_id);
	while($ddata = dbarray($query_id)) {
/*FIXME
		$dl_ratings = dbquery("SELECT vote_opt, COUNT(*) AS count"
			." FROM ".DB_PREFIX."pdp_votes"
			." WHERE dl_id='".$ddata['dl_id']."'"
			." GROUP BY vote_opt");
		$val = 0;
		$count = 0;
		while($data = dbarray($dl_ratings)) {
			$count += $data['count'];
			$val += intval($data['vote_opt'])*$data['count'];
		}
		if($count) {
			$val = 6 - intval($val/$count);
		}
		*/

		$dl_comments = dbcount("(*)", "pdp_comments",
			"(dl_id='".$ddata['dl_id']."')");

		$render_data = array(
			"name"	=> $ddata['dl_name'],
			"screen22" => $ddata['dl_pic'],
			"ver"	=> $ddata['version'],
			"href"	=> FUSION_SELF."?did=".$ddata['dl_id'],
			"desc"	=> nl2br(parseubb($ddata['dl_desc'])),
			"user"	=> "<a href='profile.php"
				."?id=".$ddata['user_id']."'>"
					.$ddata['user_name']."</a>",
			"date"	=> showdate("shortdate", $ddata['dl_mtime']),
			"downloads"=> $ddata['dl_count'],
		);
		pdp_render_dl($render_data, $dl_comments, 0);//$val);

		if(--$dl_count) {
			echo "<hr>";
		}
	}

	$link = FUSION_SELF."?catid=$catid&";
	$count = array_shift(dbarray(dbquery("SELECT COUNT(dl.dl_id)"
		." FROM ".DB_PREFIX."pdp_downloads AS dl"
		." LEFT JOIN ".DB_PREFIX."pdp_cats USING(cat_id)"
		." WHERE $where")));

	if($count > $pdp_settings['per_page']) {
		tablebreak();
		echo "<p><div align='center'>"
			.makePageNav($rowstart, $pdp_settings['per_page'],
			$count, $count, $link)."</div>";
	}
}


/*
 * content of $data array
 *   href: download description
 * FIXME
 */
if(!function_exists("pdp_render_dl")) {
function pdp_render_dl($data, $comments, $ratings) {
	global $locale;
	echo "
<table border='0' width='100%'>
<tr>
	<td width='1%'>
	
	<a href='images/".$data['screen22']."'><img src='images/".$data['screen22']."' alt='' width='100' height='73'></a></td>
	<td><b><a href='".$data['href']."'>"
		.$data['name']." ".$data['ver']."</a></b><br>"
		."<span class='small2'>".$locale['PDP214']." ".$data['user']
		." ".$data['date']."</span>"
	."</td>
	<td align='right' style='white-space:nowrap;'>"
		.$locale['PDP004'].": ".$data['downloads']."<br>"
			.$locale['PDP021'].": $comments</td>
</tr>
<tr>
	<td colspan='3'>".$data['desc']."</td>
</tr>
</table>";
}
}


/*
 * GUI
 */
if(isset($pdp_dl) && $pdp_dl['dl_status']=="N") {
	pdp_msg(false, $locale['PDP023']);
}

opentable($pdp_settings['title']);
echo $pdp_menu;


//$access_group = show_cats2($catid, isset($did), $pdp_settings['hide_cats']);
$access_group = show_cats($catid, isset($did), $pdp_settings['hide_cats']);


if(!is_null($access_group)) {
	tablebreak();
	if($pdp_settings['hide_cats']) {
		fallback("error.php?errno=".PDP_EACCESS);
	}
	echo "<table align='center' border='0'><tr>"
		."<td><img src='icons/locked.gif' alt=''></td><td>"
		.$locale['PDP215']."<b> "
		.getgroupname($access_group)."</b></td></tr></table>\n";
}
//closetable();	// FIXME: position

if(is_null($access_group) && !isset($did)) {
	show_downloads($catid);
}

if(is_null($access_group) && isset($did)) {
	tablebreak();
	include("did.php");
} else {
	// show download stats
	if(!$catid) {
		$downloads = dbcount("(*)", "pdp_downloads", "");
		$files = dbcount("(*)", "pdp_files", "");
		$query_id = dbquery("SELECT file_timestamp"
			." FROM ".DB_PREFIX."pdp_files"
			." ORDER BY file_timestamp DESC LIMIT 1");
		if(dbrows($query_id)) {
			$mtime = array_shift(dbarray($query_id));
		} else {
			$mtime = 0;
		}
		echo "<p><div align='center'>\n"
			."<b>".$locale['PDP004'].":</b> $downloads\n"
			." - <b>".$locale['PDP019'].":</b> $files\n";
		if($mtime) {
			echo " - <b>".$locale['PDP052'].":</b> "
				.showdate("shortdate", $mtime);
		}
		echo "</div>\n";
	}
	closetable();
}


require_once(BASEDIR."side_right.php");
require_once(BASEDIR."footer.php");
?>
